import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import './style';
import React, { Component } from 'react';
import { createPortal } from 'react-dom';
import cn from 'classnames';
import A from '../a';
import Modal from '../modal';

var ActionSheet =
/*#__PURE__*/
function (_Component) {
  _inheritsLoose(ActionSheet, _Component);

  function ActionSheet() {
    return _Component.apply(this, arguments) || this;
  }

  var _proto = ActionSheet.prototype;

  _proto.componentDidMount = function componentDidMount() {
    this._container = document.createElement('div');

    this._container.classList.add('_x_actionsheet_');

    document.body.appendChild(this._container);
    this.setState({});
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    document.body.removeChild(this._container);
  };

  _proto._content = function _content() {
    var _this$props = this.props,
        title = _this$props.title,
        visible = _this$props.visible,
        className = _this$props.className,
        onClose = _this$props.onClose,
        _onClick = _this$props.onClick,
        items = _this$props.items,
        closeText = _this$props.closeText,
        otherProps = _objectWithoutPropertiesLoose(_this$props, ["title", "visible", "className", "onClose", "onClick", "items", "closeText"]);

    if (!Array.isArray(items)) {
      throw new TypeError('ActionSheet 的 items 必须是个数组');
    }

    var composeClassName = cn('x-actionsheet', className);
    return React.createElement(Modal, _extends({
      visible: visible,
      onBgClick: onClose,
      className: composeClassName
    }, otherProps), !!title && React.createElement("h1", {
      className: "x-actionsheet__title"
    }, title), React.createElement("div", {
      className: "x-actionsheet__list"
    }, items.map(function (item, index) {
      var name = item.name,
          className = item.className;
      var composeClassName = cn('x-actionsheet__button', className);
      return React.createElement("div", {
        className: "x-actionsheet__item",
        key: index
      }, React.createElement(A, {
        key: index,
        className: composeClassName,
        onClick: function onClick() {
          _onClick && _onClick(item);
        }
      }, name));
    })), !!closeText && React.createElement("a", {
      href: "javascript:;",
      className: "x-actionsheet__closebtn",
      onClick: onClose
    }, closeText));
  };

  _proto.render = function render() {
    if (this._container) {
      return createPortal(this._content(), this._container);
    }

    return null;
  };

  return ActionSheet;
}(Component);

export default ActionSheet;