import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import React from 'react';
import { render, createPortal, unmountComponentAtNode } from 'react-dom';
import './style';
import A from '../a';
import cn from 'classnames';

var Alert =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Alert, _React$Component);

  function Alert() {
    return _React$Component.apply(this, arguments) || this;
  }

  var _proto = Alert.prototype;

  _proto.render = function render() {
    var _this$props = this.props,
        title = _this$props.title,
        desc = _this$props.desc,
        btns = _this$props.btns,
        onClose = _this$props.onClose;
    console.log('btns', btns);
    return React.createElement("div", {
      className: "x-alert__inner"
    }, React.createElement("div", {
      className: "x-alert__body"
    }, !!title && React.createElement("h1", null, title), React.createElement("p", {
      className: title ? '' : 'no-title'
    }, desc)), React.createElement("div", {
      className: "x-alert__btns"
    }, btns.map(function (btn, index) {
      var name = btn.name,
          className = btn.className,
          _onClick = btn.onClick,
          otherProps = _objectWithoutPropertiesLoose(btn, ["name", "className", "onClick"]);

      var composeClassName;

      if (index === 0) {
        composeClassName = cn('x-alert__btn-y', className);
      } else if (index === 1) {
        composeClassName = cn('x-alert__btn-n', className);
      } else {
        composeClassName = cn('x-alert__btn-y', className);
      }

      return React.createElement(A, _extends({
        className: composeClassName
      }, otherProps, {
        onClick: function onClick() {
          _onClick && _onClick();
          onClose();
        },
        key: index
      }), name);
    })));
  };

  return Alert;
}(React.Component);

export default function alert(params, callback) {
  var className = params.className,
      btns = params.btns;
  var div = document.createElement('div');
  div.classList.add('x-alert', 'x-alert--show');
  className && div.classList.add(className);
  document.body.appendChild(div);

  function close() {
    div.classList.remove('x-alert--show');
    div.classList.add('x-alert--hide');
    setTimeout(function () {
      unmountComponentAtNode(div);

      if (div && div.parentNode) {
        div.parentNode.removeChild(div);
      }

      callback && callback();
    }, 200);
  }

  btns = btns ? btns : [{
    name: '确定'
  }];

  if (typeof params === 'string') {
    render(createPortal(React.createElement(Alert, {
      title: params,
      btns: btns,
      onClose: close
    }), div), div);
  } else {
    render(createPortal(React.createElement(Alert, _extends({
      btns: btns
    }, params, {
      onClose: close
    })), div), div);
  }

  return {
    close: close
  };
}