import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import './style';
import React from 'react';
import cn from 'classnames';
import Spin from '../spin';
import A from '../a';

var Button = function Button(props) {
  var type = props.type,
      disabled = props.disabled,
      mini = props.mini,
      className = props.className,
      loading = props.loading,
      children = props.children,
      otherProps = _objectWithoutPropertiesLoose(props, ["type", "disabled", "mini", "className", "loading", "children"]);

  var css = cn('x-button', {
    'x-button--disabled': disabled || loading,
    'x-button--mini': mini
  }, 'x-button--' + (type || 'primary'), className);
  var composeChildren = [].concat(children);
  return React.createElement(A, _extends({}, otherProps, {
    className: css
  }), !!loading && React.createElement(Spin, {
    className: "x-button__loading"
  }), composeChildren.map(function (res, i) {
    return React.createElement("p", {
      className: "x-button__text",
      key: i
    }, res);
  }));
};

export default Button;