import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import './style';
import React, { cloneElement } from 'react';
import cn from 'classnames';
import A from '../a';

function CellRow(props) {
  var className = props.className,
      arrow = props.arrow,
      _onClick = props.onClick,
      activeable = props.activeable,
      children = props.children,
      value = props.value,
      otherProps = _objectWithoutPropertiesLoose(props, ["className", "arrow", "onClick", "activeable", "children", "value"]);

  var composeClassName = cn('x-cell__row', className, {
    'x-cell--activeable': _onClick || activeable,
    'x-cell--arrow': arrow
  });
  var Node = _onClick ? A : 'div';
  return React.createElement(Node, _extends({}, otherProps, {
    className: composeClassName,
    onClick: function onClick() {
      _onClick && _onClick(value);
    }
  }), children);
}

function Cell(props) {
  var arrow = props.arrow,
      indentLine = props.indentLine,
      className = props.className,
      children = props.children,
      onClick = props.onClick,
      otherProps = _objectWithoutPropertiesLoose(props, ["arrow", "indentLine", "className", "children", "onClick"]);

  var composeClassName = cn('x-cell', className, {
    'x-cell--indent-line': indentLine
  });
  var composeChildren = [].concat(children);
  return React.createElement("section", _extends({}, otherProps, {
    className: composeClassName
  }), composeChildren.map(function (children, index) {
    if (children.type === CellRow) {
      return cloneElement(children, {
        key: index,
        arrow: arrow || children.props.arrow,
        onClick: onClick || children.props.onClick
      });
    }

    return children;
  }));
}

Cell.Row = CellRow;
export default Cell;