import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import './style';
import React from 'react';
import { createPortal } from 'react-dom';
import cn from 'classnames';
import Modal from '../modal';

var Dialog =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Dialog, _React$Component);

  function Dialog(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    _this.div = document.createElement('div');

    _this.div.classList.add('_x_dialog_');

    document.body.appendChild(_this.div);
    return _this;
  }

  var _proto = Dialog.prototype;

  _proto.componentWillUnmount = function componentWillUnmount() {
    if (this.div && this.div.parentNode) {
      this.div.parentNode.removeChild(this.div);
    }
  };

  _proto._content = function _content() {
    var _this$props = this.props,
        className = _this$props.className,
        height = _this$props.height,
        visible = _this$props.visible,
        children = _this$props.children,
        onBgClick = _this$props.onBgClick,
        otherProps = _objectWithoutPropertiesLoose(_this$props, ["className", "height", "visible", "children", "onBgClick"]);

    var composeClassName = cn('x-dialog', className);
    return React.createElement(Modal, _extends({}, otherProps, {
      visible: visible,
      height: height,
      onBgClick: onBgClick,
      className: composeClassName
    }), React.createElement("div", {
      className: "x-dialog__inner"
    }, children));
  };

  _proto.render = function render() {
    return createPortal(this._content(), this.div);
  };

  return Dialog;
}(React.Component);

var Scroller = function Scroller(props) {
  var className = props.className,
      children = props.children;
  var composeClassName = cn('x-dialog__scroller', className);
  return React.createElement("div", {
    className: composeClassName
  }, React.createElement("div", {
    className: "x-dialog__inscroller"
  }, children));
};

Dialog.Scroller = Scroller;
export default Dialog;