import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import './style';
import React from 'react';
import cn from 'classnames';

var Input =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Input, _React$Component);

  function Input() {
    return _React$Component.apply(this, arguments) || this;
  }

  var _proto = Input.prototype;

  _proto.render = function render() {
    var _this$props = this.props,
        type = _this$props.type,
        className = _this$props.className,
        addonBefore = _this$props.addonBefore,
        addonAfter = _this$props.addonAfter,
        error = _this$props.error,
        multi = _this$props.multi,
        disabled = _this$props.disabled,
        value = _this$props.value,
        onChange = _this$props.onChange,
        otherProps = _objectWithoutPropertiesLoose(_this$props, ["type", "className", "addonBefore", "addonAfter", "error", "multi", "disabled", "value", "onChange"]);

    var composeClassName = cn('x-input', {
      'x-input--error': error,
      'x-input--multi': multi,
      'x-input--disabled': disabled
    }, className);

    if (multi) {
      return React.createElement("div", {
        className: composeClassName
      }, React.createElement("textarea", _extends({}, otherProps, {
        disabled: disabled,
        className: "x-input__ipt",
        value: value,
        onChange: onChange,
        type: type || 'text'
      })));
    }

    return React.createElement("div", {
      className: composeClassName
    }, !!addonBefore && React.createElement("div", {
      className: "x-input__addon-before"
    }, addonBefore), React.createElement("input", _extends({}, otherProps, {
      disabled: disabled,
      className: "x-input__ipt",
      value: value,
      onChange: onChange,
      type: type || 'text'
    })), !!addonAfter && React.createElement("div", {
      className: "x-input__addon-after"
    }, addonAfter));
  };

  return Input;
}(React.Component);

export default Input;