import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import './style';
import React from 'react';
import cn from 'classnames';
import Spin from '../spin';
import IPhoneXHeader from '../iphonex_header';
import IPhoneXFooter from '../iphonex_footer';

var Layout = function Layout(props) {
  var className = props.className,
      children = props.children,
      otherProps = _objectWithoutPropertiesLoose(props, ["className", "children"]);

  var composeClassName = cn('x-app', className);
  return React.createElement("div", _extends({}, otherProps, {
    className: composeClassName
  }), React.createElement(IPhoneXHeader, null), children, React.createElement(IPhoneXFooter, null));
};

var LayoutBody =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(LayoutBody, _React$Component);

  function LayoutBody(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "scroll", function (e) {
      var onScroll = _this.props.onScroll;
      onScroll && onScroll(e);
      e.preventDefault();
      var onReachBottom = _this.props.onReachBottom;

      if (onReachBottom && onReachBottom.disable) {
        return;
      }

      var wrapper = e.target;
      var inner = e.target.querySelector('.x-app-body__inner');

      if (e.target.className.indexOf('x-app-body') > -1) {
        _this.detectReachBottom(wrapper, inner);
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "detectReachBottom", function (wrapper, inner) {
      if (_this.state.bottomLoading) {
        return;
      }

      var onReachBottom = _this.props.onReachBottom;
      _this.timer && clearTimeout(_this.timer);
      _this.timer = setTimeout(function () {
        var h = inner.clientHeight;
        var bh = wrapper.clientHeight + wrapper.scrollTop; // 快滚动到底部时

        if (h - bh < 200) {
          _this.setState({
            bottomLoading: true
          },
          /*#__PURE__*/
          _asyncToGenerator(
          /*#__PURE__*/
          regeneratorRuntime.mark(function _callee() {
            return regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    _context.t0 = onReachBottom;

                    if (!_context.t0) {
                      _context.next = 4;
                      break;
                    }

                    _context.next = 4;
                    return onReachBottom.handler();

                  case 4:
                    _this.setState({
                      bottomLoading: false
                    });

                  case 5:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee, this);
          })));
        }
      }, 300);
    });

    _this.timer = null;
    _this.state = {
      bottomLoading: false
    };
    return _this;
  }

  var _proto = LayoutBody.prototype;

  _proto.content = function content() {
    var _this$props = this.props,
        loading = _this$props.loading,
        errorInfo = _this$props.errorInfo,
        children = _this$props.children;

    if (loading) {
      return React.createElement(Spin, {
        className: "x-app__loading"
      });
    } else if (errorInfo) {
      return React.createElement("p", {
        className: "x-app__error-info"
      }, React.createElement("i", null, "!"), errorInfo);
    } else {
      return children;
    }
  };

  _proto.render = function render() {
    var _this$props2 = this.props,
        loading = _this$props2.loading,
        errorInfo = _this$props2.errorInfo,
        className = _this$props2.className,
        onScroll = _this$props2.onScroll,
        onReachBottom = _this$props2.onReachBottom,
        otherProps = _objectWithoutPropertiesLoose(_this$props2, ["loading", "errorInfo", "className", "onScroll", "onReachBottom"]);

    var composeClassName = cn('x-app-body', className, {
      'x-app-body--loading': loading,
      'x-app-body--error': errorInfo
    });
    return React.createElement("div", _extends({}, otherProps, {
      className: composeClassName,
      onScroll: this.scroll
    }), React.createElement("div", {
      className: "x-app-body__inner"
    }, this.content()), onReachBottom && React.createElement("div", {
      className: "x-app-body__bottom"
    }, !this.state.bottomLoading && React.createElement("div", {
      className: "x-app-body__bottom-inner"
    }, onReachBottom.content), !!this.state.bottomLoading && React.createElement("div", {
      className: "x-app-body__bottom-inner"
    }, React.createElement(Spin, {
      text: "\u52A0\u8F7D\u4E2D..."
    }))));
  };

  return LayoutBody;
}(React.Component);

var LayoutFooter = function LayoutFooter(props) {
  var className = props.className,
      visible = props.visible,
      children = props.children,
      otherProps = _objectWithoutPropertiesLoose(props, ["className", "visible", "children"]);

  var composeClassName = cn('x-app-footer', className);

  if (visible === false) {
    return null;
  }

  return React.createElement("footer", _extends({}, otherProps, {
    className: composeClassName
  }), children);
};

var LayoutHeader = function LayoutHeader(props) {
  var className = props.className,
      children = props.children,
      ghost = props.ghost,
      addonBefore = props.addonBefore,
      onBackClick = props.onBackClick,
      onCloseClick = props.onCloseClick,
      title = props.title,
      addonAfter = props.addonAfter,
      addonBottom = props.addonBottom,
      otherProps = _objectWithoutPropertiesLoose(props, ["className", "children", "ghost", "addonBefore", "onBackClick", "onCloseClick", "title", "addonAfter", "addonBottom"]);

  var composeClassName = cn('x-app-header', {
    'x-app-header--ghost': ghost
  }, className);
  return React.createElement("header", _extends({}, otherProps, {
    className: composeClassName
  }), React.createElement("div", {
    className: "x-app-header__inner"
  }, (addonBefore || onBackClick || onCloseClick) && React.createElement("div", {
    className: "x-app-header__addon-before"
  }, !!onBackClick && React.createElement("a", {
    onClick: props.onBackClick,
    href: "javascript:;",
    className: "x-app-header__back"
  }), !!onCloseClick && React.createElement("a", {
    onClick: props.onCloseClick,
    href: "javascript:;",
    className: "x-app-header__close"
  }), addonBefore), !!title && React.createElement("h1", {
    className: "x-app-header__title"
  }, title), children, !!addonAfter && React.createElement("div", {
    className: "x-app-header__addon-after"
  }, props.addonAfter)), !!addonBottom && React.createElement("div", {
    className: "x-app-header__addon-bottom"
  }, props.addonBottom));
};

Layout.Header = LayoutHeader;
Layout.Body = LayoutBody;
Layout.Footer = LayoutFooter;
export default Layout;