import './style';
import React from 'react';
import { createPortal, unmountComponentAtNode, render } from 'react-dom';
import Spin from '../spin';
var div;

function close() {
  if (!div) return;
  unmountComponentAtNode(div);

  if (div && div.parentNode) {
    div.parentNode.removeChild(div);
  }
}

function Loading(text) {
  // 防止多次调用先 close 检查下
  close();
  div = document.createElement('div');
  div.classList.add('x-loading', 'x-loading--show');
  document.body.appendChild(div);
  render(createPortal(React.createElement("div", {
    className: "x-loading__inner"
  }, React.createElement(Spin, null), !!text && React.createElement("p", null, text)), div), div);
  return {
    close: close
  };
}

Loading.hide = close;
export default Loading;