import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import './style';
import React from 'react';
import { createPortal } from 'react-dom';
import cn from 'classnames';
import Modal from '../modal';

var Popup =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Popup, _React$Component);

  function Popup(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    var local = _this.props.local; // 在当前节点中展示

    if (local) {
      return _assertThisInitialized(_this);
    }

    _this._container = document.createElement('div');

    _this._container.classList.add('_x_popup_');

    document.body.appendChild(_this._container);
    return _this;
  }

  var _proto = Popup.prototype;

  _proto.componentWillUnmount = function componentWillUnmount() {
    this._container && document.body.removeChild(this._container);
  };

  _proto._content = function _content() {
    var _this$props = this.props,
        className = _this$props.className,
        top = _this$props.top,
        onBgClick = _this$props.onBgClick,
        height = _this$props.height,
        visible = _this$props.visible,
        noPadding = _this$props.noPadding,
        children = _this$props.children,
        otherProps = _objectWithoutPropertiesLoose(_this$props, ["className", "top", "onBgClick", "height", "visible", "noPadding", "children"]);

    var composeClassName = cn('x-popup', {
      'x-popup--top': top
    }, className);
    var composeChildren = [].concat(children);
    var hasScrollChildren = false;
    composeChildren.forEach(function (res) {
      if (res.type === Scroller && !hasScrollChildren) {
        hasScrollChildren = true;
      }
    });
    var innercss = cn('x-popup__inner', {
      'x-popup--no-scroll': hasScrollChildren,
      'x-popup--no-padding': noPadding
    }); // DOM没有local这个属性，需要删除

    delete otherProps.local;
    return React.createElement(Modal, _extends({}, otherProps, {
      visible: visible,
      height: height,
      onBgClick: onBgClick,
      className: composeClassName
    }), React.createElement("div", {
      className: innercss
    }, children));
  };

  _proto.render = function render() {
    if (this._container) {
      return createPortal(this._content(), this._container);
    } else if (this.props.local) {
      return this._content();
    }

    return null;
  };

  return Popup;
}(React.Component);

var Scroller = function Scroller(props) {
  var className = props.className,
      children = props.children,
      otherProps = _objectWithoutPropertiesLoose(props, ["className", "children"]);

  var composeClassName = cn('x-popup__scroller', className);
  return React.createElement("div", _extends({}, otherProps, {
    className: composeClassName
  }), React.createElement("div", {
    className: "x-popup__inscroller"
  }, children));
};

Popup.Scroller = Scroller;
export default Popup;