import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import './style';
import React from 'react';
import cn from 'classnames';
import A from '../a';

var Radio = function Radio(props) {
  var checked = props.checked,
      disabled = props.disabled,
      className = props.className,
      text = props.text,
      onChange = props.onChange,
      value = props.value,
      otherProps = _objectWithoutPropertiesLoose(props, ["checked", "disabled", "className", "text", "onChange", "value"]);

  var composeClassName = cn('x-radio', {
    'x-radio__checked': checked,
    'x-radio__disabled': disabled
  }, className);
  return React.createElement(A, _extends({}, otherProps, {
    className: composeClassName,
    onClick: function onClick() {
      if (disabled) {
        return;
      }

      onChange && onChange(value, text);
    }
  }), React.createElement("i", {
    className: "x-radio__icon"
  }, React.createElement("sup", {
    className: "x-radio__tick"
  })), !!text && React.createElement("span", {
    className: "x-radio__text"
  }, text));
};

export default Radio;