import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import './style';
import React from 'react';
import cn from 'classnames';

var Spin = function Spin(props) {
  var className = props.className,
      text = props.text,
      otherProps = _objectWithoutPropertiesLoose(props, ["className", "text"]);

  var loadingSpin = React.createElement("div", {
    className: "x-loading__spin"
  }, React.createElement("svg", {
    className: "x-loading__spin_circular",
    viewBox: "25 25 50 50"
  }, React.createElement("circle", {
    className: "x-loading__spin_path",
    cx: "50",
    cy: "50",
    r: "20",
    fill: "none",
    strokeWidth: "2",
    strokeMiterlimit: "10"
  })));
  var composeClassName = cn('x-spin', className);
  return React.createElement("div", _extends({}, otherProps, {
    className: composeClassName
  }), loadingSpin, !!text && React.createElement("p", {
    className: "x-spin__text"
  }, text));
};

export default Spin;