import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import './style';
import React from 'react';
import classnames from 'classnames';
import A from '../a';

var Switch = function Switch(props) {
  var i = props.i,
      o = props.o,
      active = props.active,
      icon = props.icon,
      disabled = props.disabled,
      className = props.className,
      onChange = props.onChange,
      otherProps = _objectWithoutPropertiesLoose(props, ["i", "o", "active", "icon", "disabled", "className", "onChange"]);

  var composeClassName = classnames('x-switch', {
    'x-switch--active': active,
    'x-switch--io': i && o,
    'x-switch--icon': icon,
    'x-switch--disabled': disabled
  }, className);
  var hasIO = i && o;
  return React.createElement(A, _extends({}, otherProps, {
    href: "javascript:;",
    className: composeClassName,
    onClick: onChange
  }), hasIO && React.createElement("sub", null, props.i), hasIO && React.createElement("sup", null, props.o), React.createElement("em", null));
};

export default Switch;