import './style';
import React from 'react';
import { render, createPortal, unmountComponentAtNode } from 'react-dom';
var timer = null;
export default function Toast(text, timeout) {
  if (timeout === void 0) {
    timeout = 2000;
  }

  if (timeout < 500) {
    timeout = 500;
  }

  var oldDiv = document.getElementById('j-x-toast');
  oldDiv && oldDiv.parentNode && oldDiv.parentNode.removeChild(oldDiv);
  timer && clearTimeout(timer);
  var div = document.createElement('div');
  div.classList.add('x-toast', 'x-toast--show');
  div.id = 'j-x-toast';
  document.body.appendChild(div);
  render(createPortal(React.createElement("div", {
    className: "x-toast__inner"
  }, React.createElement("p", null, text)), div), div);
  timer = setTimeout(function () {
    close();
  }, timeout);

  function close() {
    div.classList.remove('x-toast--show');
    div.classList.add('x-toast--hide');
    clearTimeout(timer);
    setTimeout(function () {
      unmountComponentAtNode(div);

      if (div && div.parentNode) {
        div.parentNode.removeChild(div);
      }
    }, 200);
  }

  return {
    close: close
  };
}