"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

require("./style");

var _react = _interopRequireWildcard(require("react"));

var _reactDom = require("react-dom");

var _classnames = _interopRequireDefault(require("classnames"));

var _a = _interopRequireDefault(require("../a"));

var _modal = _interopRequireDefault(require("../modal"));

var ActionSheet =
/*#__PURE__*/
function (_Component) {
  (0, _inheritsLoose2.default)(ActionSheet, _Component);

  function ActionSheet() {
    return _Component.apply(this, arguments) || this;
  }

  var _proto = ActionSheet.prototype;

  _proto.componentDidMount = function componentDidMount() {
    this._container = document.createElement('div');

    this._container.classList.add('_x_actionsheet_');

    document.body.appendChild(this._container);
    this.setState({});
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    document.body.removeChild(this._container);
  };

  _proto._content = function _content() {
    var _this$props = this.props,
        title = _this$props.title,
        visible = _this$props.visible,
        className = _this$props.className,
        onClose = _this$props.onClose,
        _onClick = _this$props.onClick,
        items = _this$props.items,
        closeText = _this$props.closeText,
        otherProps = (0, _objectWithoutPropertiesLoose2.default)(_this$props, ["title", "visible", "className", "onClose", "onClick", "items", "closeText"]);

    if (!Array.isArray(items)) {
      throw new TypeError('ActionSheet 的 items 必须是个数组');
    }

    var composeClassName = (0, _classnames.default)('x-actionsheet', className);
    return _react.default.createElement(_modal.default, (0, _extends2.default)({
      visible: visible,
      onBgClick: onClose,
      className: composeClassName
    }, otherProps), !!title && _react.default.createElement("h1", {
      className: "x-actionsheet__title"
    }, title), _react.default.createElement("div", {
      className: "x-actionsheet__list"
    }, items.map(function (item, index) {
      var name = item.name,
          className = item.className;
      var composeClassName = (0, _classnames.default)('x-actionsheet__button', className);
      return _react.default.createElement("div", {
        className: "x-actionsheet__item",
        key: index
      }, _react.default.createElement(_a.default, {
        key: index,
        className: composeClassName,
        onClick: function onClick() {
          _onClick && _onClick(item);
        }
      }, name));
    })), !!closeText && _react.default.createElement("a", {
      href: "javascript:;",
      className: "x-actionsheet__closebtn",
      onClick: onClose
    }, closeText));
  };

  _proto.render = function render() {
    if (this._container) {
      return (0, _reactDom.createPortal)(this._content(), this._container);
    }

    return null;
  };

  return ActionSheet;
}(_react.Component);

var _default = ActionSheet;
exports.default = _default;