"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = alert;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _react = _interopRequireDefault(require("react"));

var _reactDom = require("react-dom");

require("./style");

var _a = _interopRequireDefault(require("../a"));

var _classnames = _interopRequireDefault(require("classnames"));

var Alert =
/*#__PURE__*/
function (_React$Component) {
  (0, _inheritsLoose2.default)(Alert, _React$Component);

  function Alert() {
    return _React$Component.apply(this, arguments) || this;
  }

  var _proto = Alert.prototype;

  _proto.render = function render() {
    var _this$props = this.props,
        title = _this$props.title,
        desc = _this$props.desc,
        btns = _this$props.btns,
        onClose = _this$props.onClose;
    console.log('btns', btns);
    return _react.default.createElement("div", {
      className: "x-alert__inner"
    }, _react.default.createElement("div", {
      className: "x-alert__body"
    }, !!title && _react.default.createElement("h1", null, title), _react.default.createElement("p", {
      className: title ? '' : 'no-title'
    }, desc)), _react.default.createElement("div", {
      className: "x-alert__btns"
    }, btns.map(function (btn, index) {
      var name = btn.name,
          className = btn.className,
          _onClick = btn.onClick,
          otherProps = (0, _objectWithoutPropertiesLoose2.default)(btn, ["name", "className", "onClick"]);
      var composeClassName;

      if (index === 0) {
        composeClassName = (0, _classnames.default)('x-alert__btn-y', className);
      } else if (index === 1) {
        composeClassName = (0, _classnames.default)('x-alert__btn-n', className);
      } else {
        composeClassName = (0, _classnames.default)('x-alert__btn-y', className);
      }

      return _react.default.createElement(_a.default, (0, _extends2.default)({
        className: composeClassName
      }, otherProps, {
        onClick: function onClick() {
          _onClick && _onClick();
          onClose();
        },
        key: index
      }), name);
    })));
  };

  return Alert;
}(_react.default.Component);

function alert(params, callback) {
  var className = params.className,
      btns = params.btns;
  var div = document.createElement('div');
  div.classList.add('x-alert', 'x-alert--show');
  className && div.classList.add(className);
  document.body.appendChild(div);

  function close() {
    div.classList.remove('x-alert--show');
    div.classList.add('x-alert--hide');
    setTimeout(function () {
      (0, _reactDom.unmountComponentAtNode)(div);

      if (div && div.parentNode) {
        div.parentNode.removeChild(div);
      }

      callback && callback();
    }, 200);
  }

  btns = btns ? btns : [{
    name: '确定'
  }];

  if (typeof params === 'string') {
    (0, _reactDom.render)((0, _reactDom.createPortal)(_react.default.createElement(Alert, {
      title: params,
      btns: btns,
      onClose: close
    }), div), div);
  } else {
    (0, _reactDom.render)((0, _reactDom.createPortal)(_react.default.createElement(Alert, (0, _extends2.default)({
      btns: btns
    }, params, {
      onClose: close
    })), div), div);
  }

  return {
    close: close
  };
}