"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

require("./style");

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _spin = _interopRequireDefault(require("../spin"));

var _a = _interopRequireDefault(require("../a"));

var Button = function Button(props) {
  var type = props.type,
      disabled = props.disabled,
      mini = props.mini,
      className = props.className,
      loading = props.loading,
      children = props.children,
      otherProps = (0, _objectWithoutPropertiesLoose2.default)(props, ["type", "disabled", "mini", "className", "loading", "children"]);
  var css = (0, _classnames.default)('x-button', {
    'x-button--disabled': disabled || loading,
    'x-button--mini': mini
  }, 'x-button--' + (type || 'primary'), className);
  var composeChildren = [].concat(children);
  return _react.default.createElement(_a.default, (0, _extends2.default)({}, otherProps, {
    className: css
  }), !!loading && _react.default.createElement(_spin.default, {
    className: "x-button__loading"
  }), composeChildren.map(function (res, i) {
    return _react.default.createElement("p", {
      className: "x-button__text",
      key: i
    }, res);
  }));
};

var _default = Button;
exports.default = _default;