"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

require("./style");

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _a = _interopRequireDefault(require("../a"));

function CellRow(props) {
  var className = props.className,
      arrow = props.arrow,
      _onClick = props.onClick,
      activeable = props.activeable,
      children = props.children,
      value = props.value,
      otherProps = (0, _objectWithoutPropertiesLoose2.default)(props, ["className", "arrow", "onClick", "activeable", "children", "value"]);
  var composeClassName = (0, _classnames.default)('x-cell__row', className, {
    'x-cell--activeable': _onClick || activeable,
    'x-cell--arrow': arrow
  });
  var Node = _onClick ? _a.default : 'div';
  return _react.default.createElement(Node, (0, _extends2.default)({}, otherProps, {
    className: composeClassName,
    onClick: function onClick() {
      _onClick && _onClick(value);
    }
  }), children);
}

function Cell(props) {
  var arrow = props.arrow,
      indentLine = props.indentLine,
      className = props.className,
      children = props.children,
      onClick = props.onClick,
      otherProps = (0, _objectWithoutPropertiesLoose2.default)(props, ["arrow", "indentLine", "className", "children", "onClick"]);
  var composeClassName = (0, _classnames.default)('x-cell', className, {
    'x-cell--indent-line': indentLine
  });
  var composeChildren = [].concat(children);
  return _react.default.createElement("section", (0, _extends2.default)({}, otherProps, {
    className: composeClassName
  }), composeChildren.map(function (children, index) {
    if (children.type === CellRow) {
      return (0, _react.cloneElement)(children, {
        key: index,
        arrow: arrow || children.props.arrow,
        onClick: onClick || children.props.onClick
      });
    }

    return children;
  }));
}

Cell.Row = CellRow;
var _default = Cell;
exports.default = _default;