"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

require("./style");

var _react = _interopRequireDefault(require("react"));

var _reactDom = require("react-dom");

var _classnames = _interopRequireDefault(require("classnames"));

var _modal = _interopRequireDefault(require("../modal"));

var Dialog =
/*#__PURE__*/
function (_React$Component) {
  (0, _inheritsLoose2.default)(Dialog, _React$Component);

  function Dialog(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    _this.div = document.createElement('div');

    _this.div.classList.add('_x_dialog_');

    document.body.appendChild(_this.div);
    return _this;
  }

  var _proto = Dialog.prototype;

  _proto.componentWillUnmount = function componentWillUnmount() {
    if (this.div && this.div.parentNode) {
      this.div.parentNode.removeChild(this.div);
    }
  };

  _proto._content = function _content() {
    var _this$props = this.props,
        className = _this$props.className,
        height = _this$props.height,
        visible = _this$props.visible,
        children = _this$props.children,
        onBgClick = _this$props.onBgClick,
        otherProps = (0, _objectWithoutPropertiesLoose2.default)(_this$props, ["className", "height", "visible", "children", "onBgClick"]);
    var composeClassName = (0, _classnames.default)('x-dialog', className);
    return _react.default.createElement(_modal.default, (0, _extends2.default)({}, otherProps, {
      visible: visible,
      height: height,
      onBgClick: onBgClick,
      className: composeClassName
    }), _react.default.createElement("div", {
      className: "x-dialog__inner"
    }, children));
  };

  _proto.render = function render() {
    return (0, _reactDom.createPortal)(this._content(), this.div);
  };

  return Dialog;
}(_react.default.Component);

var Scroller = function Scroller(props) {
  var className = props.className,
      children = props.children;
  var composeClassName = (0, _classnames.default)('x-dialog__scroller', className);
  return _react.default.createElement("div", {
    className: composeClassName
  }, _react.default.createElement("div", {
    className: "x-dialog__inscroller"
  }, children));
};

Dialog.Scroller = Scroller;
var _default = Dialog;
exports.default = _default;