"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

require("./style");

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _spin = _interopRequireDefault(require("../spin"));

var _iphonex_header = _interopRequireDefault(require("../iphonex_header"));

var _iphonex_footer = _interopRequireDefault(require("../iphonex_footer"));

var Layout = function Layout(props) {
  var className = props.className,
      children = props.children,
      otherProps = (0, _objectWithoutPropertiesLoose2.default)(props, ["className", "children"]);
  var composeClassName = (0, _classnames.default)('x-app', className);
  return _react.default.createElement("div", (0, _extends2.default)({}, otherProps, {
    className: composeClassName
  }), _react.default.createElement(_iphonex_header.default, null), children, _react.default.createElement(_iphonex_footer.default, null));
};

var LayoutBody =
/*#__PURE__*/
function (_React$Component) {
  (0, _inheritsLoose2.default)(LayoutBody, _React$Component);

  function LayoutBody(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "scroll", function (e) {
      var onScroll = _this.props.onScroll;
      onScroll && onScroll(e);
      e.preventDefault();
      var onReachBottom = _this.props.onReachBottom;

      if (onReachBottom && onReachBottom.disable) {
        return;
      }

      var wrapper = e.target;
      var inner = e.target.querySelector('.x-app-body__inner');

      if (e.target.className.indexOf('x-app-body') > -1) {
        _this.detectReachBottom(wrapper, inner);
      }
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "detectReachBottom", function (wrapper, inner) {
      if (_this.state.bottomLoading) {
        return;
      }

      var onReachBottom = _this.props.onReachBottom;
      _this.timer && clearTimeout(_this.timer);
      _this.timer = setTimeout(function () {
        var h = inner.clientHeight;
        var bh = wrapper.clientHeight + wrapper.scrollTop; // 快滚动到底部时

        if (h - bh < 200) {
          _this.setState({
            bottomLoading: true
          },
          /*#__PURE__*/
          (0, _asyncToGenerator2.default)(
          /*#__PURE__*/
          _regenerator.default.mark(function _callee() {
            return _regenerator.default.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    _context.t0 = onReachBottom;

                    if (!_context.t0) {
                      _context.next = 4;
                      break;
                    }

                    _context.next = 4;
                    return onReachBottom.handler();

                  case 4:
                    _this.setState({
                      bottomLoading: false
                    });

                  case 5:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee, this);
          })));
        }
      }, 300);
    });
    _this.timer = null;
    _this.state = {
      bottomLoading: false
    };
    return _this;
  }

  var _proto = LayoutBody.prototype;

  _proto.content = function content() {
    var _this$props = this.props,
        loading = _this$props.loading,
        errorInfo = _this$props.errorInfo,
        children = _this$props.children;

    if (loading) {
      return _react.default.createElement(_spin.default, {
        className: "x-app__loading"
      });
    } else if (errorInfo) {
      return _react.default.createElement("p", {
        className: "x-app__error-info"
      }, _react.default.createElement("i", null, "!"), errorInfo);
    } else {
      return children;
    }
  };

  _proto.render = function render() {
    var _this$props2 = this.props,
        loading = _this$props2.loading,
        errorInfo = _this$props2.errorInfo,
        className = _this$props2.className,
        onScroll = _this$props2.onScroll,
        onReachBottom = _this$props2.onReachBottom,
        otherProps = (0, _objectWithoutPropertiesLoose2.default)(_this$props2, ["loading", "errorInfo", "className", "onScroll", "onReachBottom"]);
    var composeClassName = (0, _classnames.default)('x-app-body', className, {
      'x-app-body--loading': loading,
      'x-app-body--error': errorInfo
    });
    return _react.default.createElement("div", (0, _extends2.default)({}, otherProps, {
      className: composeClassName,
      onScroll: this.scroll
    }), _react.default.createElement("div", {
      className: "x-app-body__inner"
    }, this.content()), onReachBottom && _react.default.createElement("div", {
      className: "x-app-body__bottom"
    }, !this.state.bottomLoading && _react.default.createElement("div", {
      className: "x-app-body__bottom-inner"
    }, onReachBottom.content), !!this.state.bottomLoading && _react.default.createElement("div", {
      className: "x-app-body__bottom-inner"
    }, _react.default.createElement(_spin.default, {
      text: "\u52A0\u8F7D\u4E2D..."
    }))));
  };

  return LayoutBody;
}(_react.default.Component);

var LayoutFooter = function LayoutFooter(props) {
  var className = props.className,
      visible = props.visible,
      children = props.children,
      otherProps = (0, _objectWithoutPropertiesLoose2.default)(props, ["className", "visible", "children"]);
  var composeClassName = (0, _classnames.default)('x-app-footer', className);

  if (visible === false) {
    return null;
  }

  return _react.default.createElement("footer", (0, _extends2.default)({}, otherProps, {
    className: composeClassName
  }), children);
};

var LayoutHeader = function LayoutHeader(props) {
  var className = props.className,
      children = props.children,
      ghost = props.ghost,
      addonBefore = props.addonBefore,
      onBackClick = props.onBackClick,
      onCloseClick = props.onCloseClick,
      title = props.title,
      addonAfter = props.addonAfter,
      addonBottom = props.addonBottom,
      otherProps = (0, _objectWithoutPropertiesLoose2.default)(props, ["className", "children", "ghost", "addonBefore", "onBackClick", "onCloseClick", "title", "addonAfter", "addonBottom"]);
  var composeClassName = (0, _classnames.default)('x-app-header', {
    'x-app-header--ghost': ghost
  }, className);
  return _react.default.createElement("header", (0, _extends2.default)({}, otherProps, {
    className: composeClassName
  }), _react.default.createElement("div", {
    className: "x-app-header__inner"
  }, (addonBefore || onBackClick || onCloseClick) && _react.default.createElement("div", {
    className: "x-app-header__addon-before"
  }, !!onBackClick && _react.default.createElement("a", {
    onClick: props.onBackClick,
    href: "javascript:;",
    className: "x-app-header__back"
  }), !!onCloseClick && _react.default.createElement("a", {
    onClick: props.onCloseClick,
    href: "javascript:;",
    className: "x-app-header__close"
  }), addonBefore), !!title && _react.default.createElement("h1", {
    className: "x-app-header__title"
  }, title), children, !!addonAfter && _react.default.createElement("div", {
    className: "x-app-header__addon-after"
  }, props.addonAfter)), !!addonBottom && _react.default.createElement("div", {
    className: "x-app-header__addon-bottom"
  }, props.addonBottom));
};

Layout.Header = LayoutHeader;
Layout.Body = LayoutBody;
Layout.Footer = LayoutFooter;
var _default = Layout;
exports.default = _default;