"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

require("./style");

var _react = _interopRequireDefault(require("react"));

var _reactDom = require("react-dom");

var _classnames = _interopRequireDefault(require("classnames"));

var _modal = _interopRequireDefault(require("../modal"));

var Popup =
/*#__PURE__*/
function (_React$Component) {
  (0, _inheritsLoose2.default)(Popup, _React$Component);

  function Popup(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    var local = _this.props.local; // 在当前节点中展示

    if (local) {
      return (0, _assertThisInitialized2.default)(_this);
    }

    _this._container = document.createElement('div');

    _this._container.classList.add('_x_popup_');

    document.body.appendChild(_this._container);
    return _this;
  }

  var _proto = Popup.prototype;

  _proto.componentWillUnmount = function componentWillUnmount() {
    this._container && document.body.removeChild(this._container);
  };

  _proto._content = function _content() {
    var _this$props = this.props,
        className = _this$props.className,
        top = _this$props.top,
        onBgClick = _this$props.onBgClick,
        height = _this$props.height,
        visible = _this$props.visible,
        noPadding = _this$props.noPadding,
        children = _this$props.children,
        otherProps = (0, _objectWithoutPropertiesLoose2.default)(_this$props, ["className", "top", "onBgClick", "height", "visible", "noPadding", "children"]);
    var composeClassName = (0, _classnames.default)('x-popup', {
      'x-popup--top': top
    }, className);
    var composeChildren = [].concat(children);
    var hasScrollChildren = false;
    composeChildren.forEach(function (res) {
      if (res.type === Scroller && !hasScrollChildren) {
        hasScrollChildren = true;
      }
    });
    var innercss = (0, _classnames.default)('x-popup__inner', {
      'x-popup--no-scroll': hasScrollChildren,
      'x-popup--no-padding': noPadding
    }); // DOM没有local这个属性，需要删除

    delete otherProps.local;
    return _react.default.createElement(_modal.default, (0, _extends2.default)({}, otherProps, {
      visible: visible,
      height: height,
      onBgClick: onBgClick,
      className: composeClassName
    }), _react.default.createElement("div", {
      className: innercss
    }, children));
  };

  _proto.render = function render() {
    if (this._container) {
      return (0, _reactDom.createPortal)(this._content(), this._container);
    } else if (this.props.local) {
      return this._content();
    }

    return null;
  };

  return Popup;
}(_react.default.Component);

var Scroller = function Scroller(props) {
  var className = props.className,
      children = props.children,
      otherProps = (0, _objectWithoutPropertiesLoose2.default)(props, ["className", "children"]);
  var composeClassName = (0, _classnames.default)('x-popup__scroller', className);
  return _react.default.createElement("div", (0, _extends2.default)({}, otherProps, {
    className: composeClassName
  }), _react.default.createElement("div", {
    className: "x-popup__inscroller"
  }, children));
};

Popup.Scroller = Scroller;
var _default = Popup;
exports.default = _default;