"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

require("./style");

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _a = _interopRequireDefault(require("../a"));

var Radio = function Radio(props) {
  var checked = props.checked,
      disabled = props.disabled,
      className = props.className,
      text = props.text,
      onChange = props.onChange,
      value = props.value,
      otherProps = (0, _objectWithoutPropertiesLoose2.default)(props, ["checked", "disabled", "className", "text", "onChange", "value"]);
  var composeClassName = (0, _classnames.default)('x-radio', {
    'x-radio__checked': checked,
    'x-radio__disabled': disabled
  }, className);
  return _react.default.createElement(_a.default, (0, _extends2.default)({}, otherProps, {
    className: composeClassName,
    onClick: function onClick() {
      if (disabled) {
        return;
      }

      onChange && onChange(value, text);
    }
  }), _react.default.createElement("i", {
    className: "x-radio__icon"
  }, _react.default.createElement("sup", {
    className: "x-radio__tick"
  })), !!text && _react.default.createElement("span", {
    className: "x-radio__text"
  }, text));
};

var _default = Radio;
exports.default = _default;