"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = Toast;

require("./style");

var _react = _interopRequireDefault(require("react"));

var _reactDom = require("react-dom");

var timer = null;

function Toast(text, timeout) {
  if (timeout === void 0) {
    timeout = 2000;
  }

  if (timeout < 500) {
    timeout = 500;
  }

  var oldDiv = document.getElementById('j-x-toast');
  oldDiv && oldDiv.parentNode && oldDiv.parentNode.removeChild(oldDiv);
  timer && clearTimeout(timer);
  var div = document.createElement('div');
  div.classList.add('x-toast', 'x-toast--show');
  div.id = 'j-x-toast';
  document.body.appendChild(div);
  (0, _reactDom.render)((0, _reactDom.createPortal)(_react.default.createElement("div", {
    className: "x-toast__inner"
  }, _react.default.createElement("p", null, text)), div), div);
  timer = setTimeout(function () {
    close();
  }, timeout);

  function close() {
    div.classList.remove('x-toast--show');
    div.classList.add('x-toast--hide');
    clearTimeout(timer);
    setTimeout(function () {
      (0, _reactDom.unmountComponentAtNode)(div);

      if (div && div.parentNode) {
        div.parentNode.removeChild(div);
      }
    }, 200);
  }

  return {
    close: close
  };
}